import numpy as np
from scipy.optimize import curve_fit
import matplotlib.pyplot as plt


xdata = np.array([-2, -1.64, -1.33, -0.7, 0, 0.45, 1.2, 1.64, 2.32, 2.9])
ydata = np.array([0.699369, 0.700462, 0.695354, 1.03905, 1.97389, 2.41143,
                  1.91091, 0.919576, -0.730975, -1.42001])


def func(x, p1, p2):
    return p1 * np.cos(p2 * x) + p2 * np.sin(p1 * x)

coeffs, cov = curve_fit(func, xdata, ydata)


t = np.linspace(min(xdata), max(xdata), 100, endpoint=True)

new_ydata = func(t, coeffs[0], coeffs[1])

plt.figure(1)
plt.plot(xdata, ydata, 'o')
plt.plot(t, new_ydata)
plt.show()
