import matplotlib.pyplot as plt
import numpy as np
import os

file_name = input("Please input file name:")

if os.path.exists(file_name):

    with open(file_name, "r") as f:
        lines = f.readlines()
        header = lines[0].split()
        data = np.loadtxt(lines[1:])
        x, y, z = data[:, 0], data[:, 1], data[:, 2]

        plt.figure(1)
        plt.title(header[2])
        plt.xlabel(header[0])
        plt.ylabel(header[1])
        plt.tricontourf(x, y, z, 20)
        plt.xlim(np.min(x), np.max(x))
        plt.ylim(np.min(y), np.max(y))
        plt.colorbar()
        plt.show()

else:
    print("File not found!")
