from scipy.ndimage import imread
import matplotlib.pyplot as plt
import numpy as np


img = imread('moonlanding.png')

spectr = np.fft.fftshift(np.fft.fft2(img))
cut_spectr = np.copy(spectr)
xsize = 50
ysize = 50
cut_spectr[spectr.shape[0] // 2 - ysize: spectr.shape[0] // 2 + ysize,
           spectr.shape[1] // 2 - xsize: spectr.shape[1] // 2 + xsize] = 0
zero_pos = np.where(cut_spectr == 0)
cut_spectr[:] = 0
cut_spectr[zero_pos] = spectr[zero_pos]

res_img = np.fft.ifft2(cut_spectr)


plt.figure(1, figsize=(8, 8))
plt.subplot(221)
plt.title("Original image")
plt.imshow(img, cmap='gray')
ax = plt.subplot(222)
plt.title("Spectrum")
plt.imshow(np.abs(spectr), clim=(0, 20000))
ax = plt.subplot(223)
plt.title("Cut spectrum")
plt.imshow(np.abs(cut_spectr), clim=(0, 20000))
ax = plt.subplot(224)
plt.title("Reconstructed image")
plt.imshow(np.abs(res_img), cmap='gray')
plt.show()
